//
// Created:     08.09.06
// Aurthor:    Iain Gilbert
//

#if defined _gtorace_included
  #endinput
#endif

#define _gtorace_included
#pragma library gtorace
#include "gtobase"
#include "player"
#include "world"
#include "vehicles"

#define MAX_CP 250
#define MAX_RACES 50

#define RACE_STATE_DISABLED 0
#define RACE_STATE_SLEEPING 1
#define RACE_STATE_LINEUP 2
#define RACE_STATE_COUNTDOWN 3
#define RACE_STATE_RACING 4
#define INVALID_RACE_ID 0
	
new RacesCount;

enum RaceInfo {
	race_state,             // race state
	race_name[MAX_NAME],    // name of race
    race_minracers,         // minimum racers needed to race
    race_maxracetime,       // max time player can take to complete a race
    race_sleepdelay,        // time between races
    race_lineupdelay,       // time to wait for players to linup
    race_cashprize, 		// cash earned for 1st position
	race_cashentry, 		// Cash required to enter (earned by winner)
	race_xpprize, 			// xp earned for 1st position
	race_xpbonus 			// xp earned per player still in race

}

new AllowedVehicles[MAX_RACES][255];

new Race[MAX_RACES][RaceInfo];
new RACE_SIZE[MAX_RACES]; // number of checkpoints, including start and finish
new Countdown[MAX_RACES];
new sleeptimer[MAX_RACES];
new lineuptimer[MAX_RACES];
new RaceTimes[MAX_RACES][MAX_PLAYERS]; // time racers took to complete the race
new RaceTimer[MAX_RACES];
new RacerCount[MAX_RACES]; // count of ppl in race
new RaceDelay[MAX_RACES]; // how often race is ran after randomise
new CheckpointID[MAX_RACES][MAX_PLAYERS];
new Float:StartHeading[MAX_RACES];
new Position[MAX_RACES];
new RaceQuestID[MAX_RACES];
new RaceActiveCPID[MAX_RACES];
new CPSize[MAX_RACES]; // size of checkpoints

new Float:Checkpoints[MAX_RACES][MAX_CP][CoordInfo];

public CheckRace() // must be ran by timer every second
{
	for (new raceid=1; raceid<=RacesCount;raceid++)
	{
	    if (Race[raceid][race_state] != RACE_STATE_DISABLED)
		{
			if (Race[raceid][race_state] == RACE_STATE_SLEEPING)
			{
			    if (sleeptimer[raceid] >= Race[raceid][race_sleepdelay]) // if it is time to run
			    {
			    	sleeptimer[raceid] = 0;
			        StartLineup(raceid);
				}
				else
				{
					sleeptimer[raceid]++;
				}
			}
		
			if (Race[raceid][race_state] == RACE_STATE_LINEUP)
			{
		   		if (lineuptimer[raceid] >= Race[raceid][race_lineupdelay]) // if it is time to run
		    	{
		    		lineuptimer[raceid] = 0;
		        	StartCountdown(raceid);
				}
				else
				{
				    if (RacerCount[raceid] > 0)
				    {
						if ((Race[raceid][race_lineupdelay] - lineuptimer[raceid]) == 10)
						{
							new string [MAX_STRING];
							for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
							{
				    			if (IsPlayerConnected(playerid))
								{
		  							if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    							{
										format(string, sizeof(string), "Race starts in %d seconds.",(Race[raceid][race_lineupdelay] - lineuptimer[raceid]));
                	           			GameTextForPlayer(playerid, string,3000,6);
									}
								}
							}
						}
					    else if ((Race[raceid][race_lineupdelay] - lineuptimer[raceid]) == 20)
						{
							new string [MAX_STRING];
							for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
							{
				    			if (IsPlayerConnected(playerid))
								{
	  								if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    							{
										format(string, sizeof(string), "Race starts in %d seconds.",(Race[raceid][race_lineupdelay] - lineuptimer[raceid]));
                           				GameTextForPlayer(playerid, string,3000,6);
									}
								}
							}
						}
						 else if ((Race[raceid][race_lineupdelay] - lineuptimer[raceid]) == 30)
						{
							new string [MAX_STRING];
							for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
							{
					    		if (IsPlayerConnected(playerid))
								{
	  								if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
		   	 						{
										format(string, sizeof(string), "Race starts in %d seconds.",(Race[raceid][race_lineupdelay] - lineuptimer[raceid]));
   	                        			GameTextForPlayer(playerid, string,3000,6);
									}
								}
							}
						}
						else if ((Race[raceid][race_lineupdelay] - lineuptimer[raceid]) == 60)
						{
							new string [MAX_STRING];
							for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
							{
					    		if (IsPlayerConnected(playerid))
								{
		  							if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
		    						{
										format(string, sizeof(string), "Race starts in %d seconds.",(Race[raceid][race_lineupdelay] - lineuptimer[raceid]));
   	                        			GameTextForPlayer(playerid, string,3000,6);
									}
								}
							}
						}
					}
					lineuptimer[raceid]++;
				}
			}
			
			if (Race[raceid][race_state] == RACE_STATE_COUNTDOWN)
			{
	    		new string [MAX_STRING];
				for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
				{
				    if (IsPlayerConnected(playerid))
					{
	  					if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    				{
				    		if (Countdown[raceid] >= 1)
							{
								format(string, sizeof(string), "%d",Countdown[raceid]);
								PlayerPlaySound(playerid,1056,GetCPX(raceid,CheckpointID[raceid][playerid]),GetCPY(raceid,CheckpointID[raceid][playerid]),GetCPZ(raceid,CheckpointID[raceid][playerid]));
							}
							else
							{
								format(string, sizeof(string), "GO!");
								PlayerPlaySound(playerid,1057,GetCPX(raceid,CheckpointID[raceid][playerid]),GetCPY(raceid,CheckpointID[raceid][playerid]),GetCPZ(raceid,CheckpointID[raceid][playerid]));
							}
           					GameTextForPlayer(playerid, string,1000,6);
						}
		 			}
				}
				if (Countdown[raceid] > 0)
				{
					Countdown[raceid]--;
				}
				else
				{
			   		StartRace(raceid);
				}
			}

			if (Race[raceid][race_state] == RACE_STATE_RACING)
			{
			    if (RaceTimer[raceid] >= Race[raceid][race_maxracetime]) // if time limit reached
		    	{
			    	EndRace(raceid);
				}
	 			RaceTimer[raceid]++;
	 		}
		}
	}
}

public RegisterRace(name[MAX_NAME])
{
	RacesCount++;
	if (RacesCount >= MAX_RACES) return INVALID_RACE_ID;
 	new raceid = RacesCount;
 	RaceQuestID[raceid] = RegisterQuest(name);
 	if (RaceQuestID[raceid] == INVALID_RACE_ID)
	{
		RacesCount--;
 		return INVALID_RACE_ID;
	}
	Race[raceid][race_name] = name;
 	return raceid;
}

public StartRace(raceid)
{
	Race[raceid][race_state] = RACE_STATE_RACING;
	
	for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
	{
	    if (IsPlayerConnected(playerid))
		{
	    	if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    	{
				TogglePlayerControllable(playerid, 1);
				NextCP(raceid,playerid);
			}
		}
	}
}
public JoinRace(raceid,playerid)
{
	GameTextForPlayer(playerid, "~r~Race Entered.",3000,6);
	RacerCount[raceid]++;
	PlayerQuest[playerid] = GetQuestID(raceid);
	CheckpointID[raceid][playerid] = 0;
	if (Race[raceid][race_state] == RACE_STATE_LINEUP)
	{
	    new string[MAX_STRING];
		format(string, sizeof(string), "Race Entered. Starts in %d seconds.",(Race[raceid][race_lineupdelay] - lineuptimer[raceid]));
 		SendPlayerFormattedText(playerid, string, 0,COLOR_RED);
	}
}

public LeaveRace(raceid,playerid)
{
	if (playerid == INACTIVE_PLAYER_ID) return;
	if (!IsPlayerConnected(playerid)) return;
	ResetQuest(playerid);  // reset checkpoints
	RacerCount[raceid]--;
	CheckpointID[raceid][playerid] = 0;
	
	new name[MAX_NAME];
	name = oGetPlayerName(playerid);
	for (new racerid=0; racerid<MAX_PLAYERS;racerid++)
	{
	    if (PlayerQuest[racerid] == GetQuestID(raceid)) // if player is in this race
	    {
	        new string[40];
	        format(string, sizeof(string),"%s has left the race.",name);
	        SendPlayerFormattedText(racerid, string, 0,COLOR_RED);
		}
	}
}

public GetQuestID(raceid)
{
	return RaceQuestID[raceid];
}

public Cleanup(raceid)
{
	for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
	{
		if (!IsPlayerConnected(playerid)) continue;
	    if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    {
			if (Race[raceid][race_state] == RACE_STATE_LINEUP)
			{
		    	GameTextForPlayer(playerid, "~r~Race Aborted.",1000,6);
		    	SendPlayerFormattedText(playerid, "Race Aborted.", 0,COLOR_RED);
			}
		    LeaveRace(raceid,playerid);
		}
		else
		{
			if (loccmp(PlayerCP[playerid][Coord_X],PlayerCP[playerid][Coord_Y],PlayerCP[playerid][Coord_Z],Checkpoints[raceid][0][Coord_X],Checkpoints[raceid][0][Coord_Y],Checkpoints[raceid][0][Coord_Z])) // if this is players current cp
	   		{
	   			ResetQuest(playerid);  // reset checkpoints
				CheckpointID[raceid][playerid] = 0;
			}
 		}
	}
	Position[raceid] = 0;
	RacerCount[raceid] = 0;
	RaceTimer[raceid] = 0;
	Race[raceid][race_state] = RACE_STATE_SLEEPING;
	RaceDelay[raceid] = Vary(Race[raceid][race_sleepdelay],(Race[raceid][race_sleepdelay]-10));
	
	if (RaceActiveCPID[raceid] != 0)
	{
		RemoveActiveCheckpoint(RaceActiveCPID[raceid]);
		RaceActiveCPID[raceid] = 0;
	}
}

public NextCP(raceid,playerid)
{

	if (CheckpointID[raceid][playerid] == RACE_SIZE[raceid]-1) // if finish line
	{
		FinishRace(raceid,playerid);
		return;
	}

	PlayerPlaySound(playerid,1058,GetCPX(raceid,CheckpointID[raceid][playerid]),GetCPY(raceid,CheckpointID[raceid][playerid]),GetCPZ(raceid,CheckpointID[raceid][playerid]));
    CheckpointID[raceid][playerid]++;
    oSetPlayerCheckpoint(playerid,GetCPX(raceid,CheckpointID[raceid][playerid]),GetCPY(raceid,CheckpointID[raceid][playerid]),GetCPZ(raceid,CheckpointID[raceid][playerid]),CPSize[raceid]);
}

public StartCountdown(raceid)
{
	if (RaceActiveCPID[raceid] != 0)
	{
		RemoveActiveCheckpoint(RaceActiveCPID[raceid]);
		RaceActiveCPID[raceid] = 0;
	}
		
		
	new string[100];
	if (RacerCount[raceid] < Race[raceid][race_minracers])
	{
		format(string, sizeof(string), "Race: '%s' did not run. Not enough racers. (%d/%d)",Race[raceid][race_name],RacerCount[raceid],Race[raceid][race_minracers]);
		SendClientMessageToRegistered(COLOR_RED, string);
		Cleanup(raceid);
		return;
	}

	format(string, sizeof(string), "Race: %s starting.",Race[raceid][race_name]);
	SendClientMessageToRegistered(COLOR_GREEN, string);

	Race[raceid][race_state] = RACE_STATE_COUNTDOWN;
	Countdown[raceid] = 4;
	for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
	{
		if (!IsPlayerConnected(playerid)) continue;
	    if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    {
	   	    if (oIsPlayerInCheckpoint(playerid,GetCPX(raceid,0),GetCPY(raceid,0),GetCPZ(raceid,0),50))
	   	    {
				TogglePlayerControllable(playerid, 0);
				SetCameraBehindPlayer(playerid);
    			SetVehicleZAngle(GetPlayerVehicleID(playerid), StartHeading[raceid]);
			}
			else
			{
			    LeaveRace(raceid,playerid);
			    GameTextForPlayer(playerid, "~r~Race Aborted.",1000,6);
		    	SendPlayerFormattedText(playerid, "Race Aborted. You are not at startline.", 0,COLOR_RED);
		    }
 		}
	}
}

public EndRace(raceid)
{
	for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
	{
		if (!IsPlayerConnected(playerid)) continue;
	    if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
     	{
	      GameTextForPlayer(playerid, "~r~Race Failed!",5000,6);
	      SendPlayerFormattedText(playerid, "Race ended. You failed to quilify.", 0,COLOR_RED);
	      GivePlayerXP(playerid,0-(Race[raceid][race_xpprize]/3),1);
		}
  	}
	Cleanup(raceid);
}

public FormatPosition(position)
{
	new string[MAX_STRING];
	if (position == 1)
	{
	    format(string, sizeof(string), "%dst!",position);
	}
	else if (position == 2)
	{
		format(string, sizeof(string), "%dnd!",position);
	}
	else if (position == 3)
	{
		format(string, sizeof(string), "%drd!",position);
	}
	else
	{
		format(string, sizeof(string), "%dth",position);
	}
	return string;
}


public FinishRace(raceid,playerid)
{
        Position[raceid]++;
		new string[MAX_STRING];
        RaceTimes[raceid][playerid] = RaceTimer[raceid];
        
        if (Position[raceid] == 1)
        {
            GivePlayerXP(playerid,Race[raceid][race_xpprize] + (Race[raceid][race_xpbonus] * RacerCount[raceid]),1);
			oGivePlayerMoney(playerid,Race[raceid][race_cashprize],1);
        	format(string, sizeof(string), "%s has won race '%s'! Time: %s.",oGetPlayerName(playerid),Race[raceid][race_name],ConvertSeconds(RaceTimes[raceid][playerid]));
            SendClientMessageToRegistered(COLOR_GREEN, string);
	    }
        else if (Position[raceid] == 2)
        {
            if (RacerCount[raceid] > 2)
            {
            	GivePlayerXP(playerid,(Race[raceid][race_xpprize]/2) + (Race[raceid][race_xpbonus] * RacerCount[raceid]),1);
				oGivePlayerMoney(playerid,(Race[raceid][race_cashprize]/2),1);
			}
			else
			{
			    GivePlayerXP(playerid,Race[raceid][race_xpbonus] * RacerCount[raceid],1);
			}

			format(string, sizeof(string), "%s finished %s in race '%s'. Time: %s.",oGetPlayerName(playerid),FormatPosition(Position[raceid]),Race[raceid][race_name],ConvertSeconds(RaceTimes[raceid][playerid]));
            SendClientMessageToRegistered(COLOR_GREEN, string);
		}
        else if ((Position[raceid] == 3) && (RacerCount[raceid] > 3))
        {
            if (RacerCount[raceid] > 3)
            {
        		GivePlayerXP(playerid,(Race[raceid][race_xpprize]/3) + (Race[raceid][race_xpbonus] * RacerCount[raceid]),1);
				oGivePlayerMoney(playerid,(Race[raceid][race_cashprize]/3),1);
			}
			else
			{
			    GivePlayerXP(playerid,Race[raceid][race_xpbonus] * RacerCount[raceid],1);
			}
			format(string, sizeof(string), "%s finished %s in race '%s'. Time: %s.",oGetPlayerName(playerid),FormatPosition(Position[raceid]),Race[raceid][race_name],ConvertSeconds(RaceTimes[raceid][playerid]));
            SendClientMessageToRegistered(COLOR_GREEN, string);
		}
        else
        {
        	GivePlayerXP(playerid,Race[raceid][race_xpbonus] * RacerCount[raceid],1);
        	format(string, sizeof(string), "You have finished race '%s'. Position: %s. Time: %s.",Race[raceid][race_name],FormatPosition(Position[raceid]),ConvertSeconds(RaceTimes[raceid][playerid]));
			SendClientMessage(playerid,COLOR_GREEN, string);
		}
		
		string = FormatPosition(Position[raceid]);
		GameTextForPlayer(playerid,string,5000,6);
		PlayerPlaySound(playerid,1057,GetCPX(raceid,CheckpointID[raceid][playerid]),GetCPY(raceid,CheckpointID[raceid][playerid]),GetCPZ(raceid,CheckpointID[raceid][playerid]));
		LeaveRace(raceid,playerid);
}

public StartLineup(raceid)
{
        Race[raceid][race_state] = RACE_STATE_LINEUP;
		new string[MAX_STRING];
		format(string, sizeof(string), "Race: '%s'. Starting in %d seconds. Location: '%s'.",Race[raceid][race_name],Race[raceid][race_lineupdelay],GetCPZoneName(raceid,0));
		SendClientMessageToRegistered(COLOR_RACE, string);
		format(string, sizeof(string), "First Prize: $%d. Entry Fee: $%d. Minimum racers: %d.",Race[raceid][race_cashprize],Race[raceid][race_cashentry],Race[raceid][race_minracers]);
		SendClientMessageToRegistered(COLOR_RACE, string);
		for (new playerid=0; playerid<MAX_PLAYERS;playerid++)
		{
			if (!IsPlayerConnected(playerid)) continue;
		    if (PlayerQuest[playerid] == 0) // if player not on a quest
	    	{
	   				oSetPlayerCheckpoint(playerid,GetCPX(raceid,0),GetCPY(raceid,0),GetCPZ(raceid,0),12);
			}
		}
		RaceActiveCPID[raceid] = AddActiveCheckpoint(GetCPX(raceid,0),GetCPY(raceid,0),GetCPZ(raceid,0),10000,10);

}
public Float:GetCPX(raceid,cpid)
{
	return Checkpoints[raceid][cpid][Coord_X];
}
public Float:GetCPY(raceid,cpid)
{
	return Checkpoints[raceid][cpid][Coord_Y];
}
public Float:GetCPZ(raceid,cpid)
{
	return Checkpoints[raceid][cpid][Coord_Z];
}

public GetCPZoneName(raceid,cpid)
{
	new zone[MAX_NAME];
	zone = GetXYZZoneName(GetCPX(raceid,cpid),GetCPY(raceid,cpid),GetCPZ(raceid,cpid));
	return zone;
}

public OnPlayerEnterRaceCheckpoint(playerid)
{
	new PlayerState = GetPlayerState(playerid);
	for (new raceid=1; raceid<=RacesCount;raceid++)
	{
	    if (Race[raceid][race_state] == RACE_STATE_DISABLED) break;
		
	    if (Race[raceid][race_state] == RACE_STATE_LINEUP)
		{
	    	if (PlayerQuest[playerid] == 0) // if player not on a quest
	    	{
		  		// if player at startline
				if (oIsPlayerInCheckpoint(playerid,GetCPX(raceid,0),GetCPY(raceid,0),GetCPZ(raceid,0),(CPSize[raceid]*3)))
				{ //if (IsPlayercp == thiscp1)
					if (Race[raceid][race_state] == RACE_STATE_LINEUP)
					{
						if(PlayerState != PLAYER_STATE_DRIVER && PlayerState != PLAYER_STATE_PASSENGER)
						{
		   					GameTextForPlayer(playerid, "~w~You need a car to race!",2000,6);
		  					//return;
						}
						if(PlayerState == PLAYER_STATE_PASSENGER)
						{
		    				GameTextForPlayer(playerid, "~w~You need to be the driver to race!",2000,6);
		    				//return;
						}
						if(PlayerState == PLAYER_STATE_DRIVER)
						{
							new string[MAX_STRING];
						    new playervehiclemodel = GetSpawnVehicleModel(GetPlayerVehicleID(playerid)-1);

						    if (VehicleAllowedInRace(raceid,playervehiclemodel) == 1)
							{
						    	JoinRace(raceid,playerid);
						    }
							else
						    {
								SendClientMessage(playerid,COLOR_RED, "This vehicle is not allowed in this race.");
								if (strlen(AllowedVehicles[raceid]) <= 6)
								{
									set(string,"Allowed vehicles: ");
									for (new i=0;i<strlen(AllowedVehicles[raceid]);i++)
									{
						    		    if (AllowedVehicles[raceid][i] == 0)  break;
						    		    new carmodel = AllowedVehicles[raceid][i];
						    		    if (i>0) strins(string, ", ", strlen(string));
                                        strins(string, GetVehicleName(carmodel), strlen(string));
									}
									SendClientMessage(playerid,COLOR_GREY, string);
								}
								else
								{
								
									SendPlayerScrollingText(playerid,"~g~Allowed vehicles: ");
									for (new i=0;i<strlen(AllowedVehicles[raceid]);i++)
									{
							    	    if (AllowedVehicles[raceid][i] == 0)  break;
							    	    new carmodel = AllowedVehicles[raceid][i];
										format(string,sizeof(string),"%s",GetVehicleName(carmodel));
										SendPlayerScrollingText(playerid,string);
									}
								}
							}
      					}
					}
				}
			}
		}
		else if (Race[raceid][race_state] == RACE_STATE_RACING)
		{
			if (PlayerQuest[playerid] == GetQuestID(raceid)) // if player is in this race
	    	{
			    if(PlayerState == PLAYER_STATE_DRIVER)
       {
			    	if (oIsPlayerInCheckpoint(playerid,GetCPX(raceid,CheckpointID[raceid][playerid]),GetCPY(raceid,CheckpointID[raceid][playerid]),GetCPZ(raceid,CheckpointID[raceid][playerid]),CPSize[raceid]*3))
			    	{
         				if(PlayerState == PLAYER_STATE_DRIVER)
						{
						    new string[MAX_STRING];
						    new playervehiclemodel = GetSpawnVehicleModel(GetPlayerVehicleID(playerid)-1);

						    if (VehicleAllowedInRace(raceid,playervehiclemodel) == 1)
							{
						    	NextCP(raceid,playerid);
						    }
							else
						    {
								SendClientMessage(playerid,COLOR_RED, "This vehicle is not allowed in this race.");
								if (strlen(AllowedVehicles[raceid]) <= 6)
								{
									set(string,"Allowed vehicles: ");
									for (new i=0;i<strlen(AllowedVehicles[raceid]);i++)
									{
						    		    if (AllowedVehicles[raceid][i] == 0)  break;
						    		    new carmodel = AllowedVehicles[raceid][i];
						    		    if (i>0) strins(string, ", ", strlen(string));
                                        strins(string, GetVehicleName(carmodel), strlen(string));
									}
									SendClientMessage(playerid,COLOR_GREY, string);
								}
								else
								{

									SendPlayerScrollingText(playerid,"~g~Allowed vehicles: ");
									for (new i=0;i<strlen(AllowedVehicles[raceid]);i++)
									{
							    	    if (AllowedVehicles[raceid][i] == 0)  break;
							    	    new carmodel = AllowedVehicles[raceid][i];
										format(string,sizeof(string),"%s",GetVehicleName(carmodel));
										SendPlayerScrollingText(playerid,string);
									}
								}
							}
						}
					}
				}
				else
				{
     				GameTextForPlayer(playerid, "~w~Get a car to race.",2000,6);
				}
		    }
		}
	}
}

public VehicleAllowedInRace(raceid,vehiclemodel)
{
    if (AllowedVehicles[raceid][0] == 0) return 1;
    new vehicleallowed;
    
    for (new i=0;i<strlen(AllowedVehicles[raceid]);i++)
	{
	  	if (vehiclemodel == AllowedVehicles[raceid][i])
		{
		 	vehicleallowed = 1;
		 	break;
		 }
	}
	return vehicleallowed;
}
