//
// Created:     05.09.06
// Aurthor:    Iain Gilbert
//

#if defined _player_included
  #endinput
#endif

#define _player_included
#pragma library player
#include "gtobase"
#include "gtoutils"
#include "dutils"
#include "gtodudb"
#include "account"
#include "weapons"

#define MAX_PLAYERS 100 

enum PlayerInfo {
	IsActive, 	// is player online
	Float:Health, 	// health
	Money,          // Money
	Bank,           // Money in bank
	Level,          // Level
	XP,             // XP
    Deaths,         // Deaths
    Kills,          // Kills
    CarKills        // cars killed

}

new PlayerSkin[MAX_PLAYERS];
new PlayerWeapons[MAX_PLAYERS][MAX_WEAPONS];

new PlayerCurrentKills[MAX_PLAYERS];

new PlayerGangid[MAX_PLAYERS];
new PlayerGangName[MAX_PLAYERS][MAX_NAME];

new Player[MAX_PLAYERS][PlayerInfo];

new PlayerSpawn[MAX_PLAYERS][CoordInfo];
new SpawnTime[MAX_PLAYERS];

enum Quest_Stats {
    Quest_Name[MAX_NAME]
}

new PlayerQuest[MAX_PLAYERS]; // holds id of quest player is currently doing
new Quests[MAX_QUESTS][Quest_Stats]; // table of all registered quests
new QuestCount;

new Float:PlayerCP[MAX_PLAYERS][CoordInfo];
new bool:PlayerCPActive[MAX_PLAYERS];

new MoneyKick[MAX_PLAYERS];
new HealthKick[MAX_PLAYERS];
new MoneyUpdateDelay[MAX_PLAYERS];
new HealthUpdateDelay[MAX_PLAYERS];

// spawn lists by SA:MP team
new Float:gRandomPlayerSpawns[23][CoordInfo] = {
{1958.3783,1343.1572,15.3746},
{2199.6531,1393.3678,10.8203},
{2483.5977,1222.0825,10.8203},
{2637.2712,1129.2743,11.1797},
{2000.0106,1521.1111,17.0625},
{2024.8190,1917.9425,12.3386},
{2261.9048,2035.9547,10.8203},
{2262.0986,2398.6572,10.8203},
{2244.2566,2523.7280,10.8203},
{2335.3228,2786.4478,10.8203},
{2150.0186,2734.2297,11.1763},
{2158.0811,2797.5488,10.8203},
{1969.8301,2722.8564,10.8203},
{1652.0555,2709.4072,10.8265},
{1564.0052,2756.9463,10.8203},
{1271.5452,2554.0227,10.8203},
{1441.5894,2567.9099,10.8203},
{1480.6473,2213.5718,11.0234},
{1400.5906,2225.6960,11.0234},
{1598.8419,2221.5676,11.0625},
{1318.7759,1251.3580,10.8203},
{1558.0731,1007.8292,10.8125},
{1705.2347,1025.6808,10.8203}
};


public SpawnTimer()
{
	for (new playerid=0;playerid<MAX_PLAYERS;playerid++)
	{
		if (IsPlayerConnected(playerid))
		{
		    SpawnTime[playerid]++;
		}
	}
}
	

// needs to be ran by a timer
// sync player hp/money and check for mismatch
public SyncPlayers()
{
	for (new playerid = 0; playerid < MAX_PLAYERS; playerid++)
	{
		if (!IsPlayerConnected(playerid)) continue;
		SyncMoney(playerid);
		SyncHealth(playerid);
	}
	return;
}

new PlayerCasinoMoney[MAX_PLAYERS];

public SyncMoney(playerid)
{

	if (!IsPlayerConnected(playerid))
	{
        if (PlayerCasinoMoney[playerid] != 0) PlayerCasinoMoney[playerid] = 0;
		return;
	}

	if (MoneyKick[playerid] >= 3) KickPlayer(playerid,"Money desync.(Possible cheat, probably just lagg or packet loss)");

	if (MoneyUpdateDelay[playerid] > 0)
	{
		MoneyUpdateDelay[playerid] = 0;
		return;
	}
	
	new clientmoney;
	clientmoney = GetPlayerMoney(playerid);

	if (clientmoney == Player[playerid][Money]) //
	{
		MoneyKick[playerid] = 0;
		return;
	}

	if (IsPlayerInCasino(playerid))
	{
	  	if (clientmoney > Player[playerid][Money]+(MAX_WIN*2)) // if players money is lots more
		{
		    new string[MAX_STRING];
	  		format(string,sizeof(string),"Warning: Maximum gambling win: $%d.",MAX_WIN);
			SendClientMessage(playerid,COLOR_RED, string);
			SetPlayerMoney(playerid,Player[playerid][Money]+MAX_WIN); // set money
			MoneyKick[playerid]++; //
			PlayerCasinoMoney[playerid] = PlayerCasinoMoney[playerid]+MAX_WIN;
			if (clientmoney == Player[playerid][Money])
    		{
               	MoneyKick[playerid]=0;
			}
		}
		else if (clientmoney > Player[playerid][Money])
		{
		    new win = clientmoney - Player[playerid][Money];
			new string[MAX_STRING];
	  		format(string,sizeof(string),"You have won $%d.",win);
			SendClientMessage(playerid,COLOR_MONEY_GOOD, string);
            PlayerCasinoMoney[playerid] = PlayerCasinoMoney[playerid]+win;
			oSetPlayerMoney(playerid,clientmoney);
			MoneyKick[playerid]=0;
		}
		else // clientmoney must be <= severmoney
		{
		    new loss;
		    loss = clientmoney + Player[playerid][Money];
			oSetPlayerMoney(playerid,clientmoney);
			MoneyKick[playerid]=0;
			PlayerCasinoMoney[playerid] = PlayerCasinoMoney[playerid]-loss;
		}

		if (PlayerCasinoMoney[playerid] > MAX_WIN*1.5)
		{
			new string[MAX_STRING];
	   		format(string,sizeof(string),"You have won too much money in this casino. The bouncer asks you to leave.",MAX_WIN);
			SendClientMessage(playerid,COLOR_RED, string);
			if (clientmoney > PlayerCasinoMoney[playerid] + MAX_WIN*2)
			{
				KickPlayer(playerid,"Kicked by casino bouncer. Won too much in casino, did not leave when asked.");
			}
		}
	}
	else
	{
		PlayerCasinoMoney[playerid] = 0;
	}


	if (clientmoney < 0) // if negative value
	{
		MoneyKick[playerid]++;
		oSetPlayerMoney(playerid,0);
		return;
	}

	if (clientmoney < Player[playerid][Money]) // if players money is less (they bought something)
	{
	    if (!IsPlayerAtBank(playerid))
	    {
			Player[playerid][Money] = clientmoney; // set our money to player money
			MoneyKick[playerid] = 0;
		}
	}


	if (clientmoney > Player[playerid][Money]) // if players money is more
	{
		if (clientmoney > Player[playerid][Money]+MAX_WIN*2) // if players money is lots more
		{
			KickPlayer(playerid,"Your money has lost sync with server.");

			#if DEBUGLEVEL > 0
				printf("Player money lots more: %d",playerid);
			#endif
			return;
		}

		if (!IsPlayerInCasino(playerid))
		{
			SetPlayerMoney(playerid,Player[playerid][Money]); // set money
			MoneyKick[playerid]++; //

			if (clientmoney == Player[playerid][Money])
	    	{
                MoneyKick[playerid]=0;
			}
		}

	}

	if (clientmoney != Player[playerid][Money]) // if still not equal
	{
		MoneyKick[playerid]++; //
		oSetPlayerMoney(playerid,Player[playerid][Money]);
		return;
	}
	return;
}

public SyncHealth(id)
{
	if (!IsPlayerConnected(id)) return;
	if (HealthKick[id] >= 3) KickPlayer(id,"Health desync. (Possible cheat, probably just lagg or packet loss)");

	if (HealthUpdateDelay[id] > 0)
	{
		HealthUpdateDelay[id] = 0;
		return;
	}


	new Float:clienthealth;
	clienthealth = oGetPlayerHealth(id);

	if (clienthealth < 0) // if we have negative health
	{
		HealthKick[id] = 0;
		oSetPlayerHealth(id,0);
		return;
	}

	if (clienthealth == Player[id][Health]) // if our health valus match
	{
		HealthKick[id] = 0;
		return;
	}

    if (clienthealth < Player[id][Health]) // if client has less health
	{
	   HealthKick[id] = 0;
		Player[id][Health] = clienthealth; // update our server value
	}

	if (clienthealth > Player[id][Health]) // if client has more health
	{
	    //if (Player[id][Health] == 0) return;
		if (!IsPlayerInStore(id))
		{
			HealthKick[id]++;
			SetPlayerHealth(id,Player[id][Health]);
			#if DEBUGLEVEL > 0
				printf("health >: %d|%f|%f",HealthKick[id],clienthealth,Player[id][Health]);
			#endif
		}
		else // player in store
		{
		    if (clienthealth <= 100)
		    {
		    	oSetPlayerHealth(id,clienthealth);
		    	HealthKick[id]=0;
		    }
		    else
		    {
		    	HealthKick[id]++;
		    }
		}
		return;
	}

	if (clienthealth != Player[id][Health]) // if still not equal
	{
		SetPlayerHealth(id,Player[id][Health]);
		HealthKick[id]++; //
	}
	HealthRegen(id);
	return;
}

public HealthRegen(id)
{
	if (Player[id][Health] < MIN_HEALTH+(Player[id][Level]*5.0)) // if we regenerate health
	{
    	new Float:newhealth;
    	newhealth = Player[id][Health]+(1+(Player[id][Level]/2.0));
		oSetPlayerHealth(id, newhealth); // give some health
		#if DEBUGLEVEL > 3
			printf("health regen:%f|%f",newhealth,(1+(Player[id][Level]/2.0)));
		#endif
	}
}

public GivePlayerOwnedWeapons(playerid)
{
	for (new i = 1;i<MAX_WEAPONS;i++)
	{
	    if (IsPlayerAllowedWeapon(playerid,i))
	    {
			if (PlayerWeapons[playerid][i] > 0) GivePlayerWeapon(playerid,i,PlayerWeapons[playerid][i]);
		}
	}
}

public SendPlayerOwnedWeapons(playerid)
{
	new string[MAX_STRING];
	SendPlayerFormattedText(playerid, "Owned weapons:" , 0,COLOR_GREEN);
	for (new weaponid=1;weaponid<MAX_WEAPONS;weaponid++)
	{
		if (PlayerWeapons[playerid][weaponid] <= 0) continue;
		if (PlayerWeapons[playerid][weaponid] > 1)
		{
			format(string,sizeof(string),"Weapon: '%s'. Ammo: %d.",oGetWeaponName(weaponid),PlayerWeapons[playerid][weaponid]);
			SendPlayerFormattedText(playerid, string,0,COLOR_MISC);
		}
		else if (PlayerWeapons[playerid][weaponid] == 1)
		{
			format(string,sizeof(string),"Weapon: '%s'.",oGetWeaponName(weaponid));
			SendPlayerFormattedText(playerid, string,0,COLOR_MISC);
		}
	}
}

public player_Spawn(playerid)
{

   	SpawnTime[playerid] = 0;
	SetPlayerInterior(playerid,0);

	if ((PlayerSpawn[playerid][Coord_X] !=0.0) && (PlayerSpawn[playerid][Coord_Y] !=0.0) && (PlayerSpawn[playerid][Coord_Z] !=0.0))
	{
		SetPlayerPos(playerid, PlayerSpawn[playerid][Coord_X], PlayerSpawn[playerid][Coord_Y], PlayerSpawn[playerid][Coord_Z]); // Warp the player
		PlayerSpawn[playerid][Coord_X] = 0.0;
		PlayerSpawn[playerid][Coord_Y] = 0.0;
		PlayerSpawn[playerid][Coord_Z] = 0.0;
	}
	else
	{
		new rand = random(sizeof(gRandomPlayerSpawns));
		SetPlayerPos(playerid, gRandomPlayerSpawns[rand][Coord_X], gRandomPlayerSpawns[rand][Coord_Y], gRandomPlayerSpawns[rand][Coord_Z]); // Warp the player
	}

	if (IsPlayerRegistered(playerid))
	{
	    GivePlayerOwnedWeapons(playerid);
		oSetPlayerHealth(playerid,GetMaxHealth(playerid)); // set health based on level
	}
	else
	{
	    SendClientMessage(playerid,COLOR_RED, "!!WARNING!! You are not logged in, player stats will not be saved.");
		SendClientMessage(playerid,COLOR_RED, "To create an account use '/register <password>'.");
	    SendClientMessage(playerid,COLOR_RED, "To log-in to an existing account use '/login <password>'.");
        GivePlayerOwnedWeapons(playerid);
		oSetPlayerHealth(playerid,GetMaxHealth(playerid)); // set health based on level
	}

	oSetPlayerMoney(playerid,Player[playerid][Money]);
	
}

public player_ResetStats(playerid)
{

	// reset player stats
	PlayerRegistered[playerid] = false;
	
	Player[playerid][Level] = 0;
	Player[playerid][XP] = 0;
	oSetPlayerMoney(playerid,0);
	Player[playerid][Kills] = 0;
	Player[playerid][Deaths] = 0;
	KickList[playerid] = 0;
	ResetQuest(playerid);
	SpawnTime[playerid] = 0;
	PlayerGangid[playerid] = 0;
	PlayerSkin[playerid] = 0;
	for (new i=1;i<MAX_WEAPONS;i++)
	{
		PlayerWeapons[playerid][i] = 0;
	}
	PlayerWeapons[playerid][0] = 1; // fists
}

public IsPlayerRegistered(playerid)
{
	if (playerid == INVALID_PLAYER_ID) return 0;
	if (Player[playerid][IsActive] == 0) return 0;
	if (!IsPlayerConnected(playerid)) return 0;
	if (PlayerRegistered[playerid] == 0) return 0;
	return 1;
}

public player_Disconnect(playerid)
{
	new gangid;
  	gangid = PlayerGangid[playerid];
	GangMemberLogout(playerid,gangid);
	Player[playerid][IsActive] = 0;
	player_ResetStats(playerid);
}

public player_Connect(playerid)
{
	Player[playerid][IsActive] = 1;
	player_ResetStats(playerid);

	new playername[MAX_STRING];
	set(playername,oGetPlayerName(playerid));
	if (!NameCharCheck(playername))
	{
		SendPlayerFormattedText(playerid, "ERROR: BAD CHARACTER IN PLAYERNAME.", 0,COLOR_RED);
		KickPlayer(playerid,"Invalid character in playername."); // kick player
	}
}

public PlayerDeath(playerid,killerid,reason)
{
	Player[playerid][Deaths]++;
	PlayerCurrentKills[playerid] = 0;
	if (oGetPlayerHealth(killerid) > 100)
    {
       KickList[killerid] = 1;
	}
	if ((Player[playerid][Money] - 100) > 0)
	{
		Player[playerid][Money] = Player[playerid][Money] - 100;
	}
	else
	{
		oSetPlayerMoney(playerid,0);
	}
	if ((Player[playerid][XP] - (Player[playerid][XP] / 40)) > 0)
	{
		GivePlayerXP(playerid, (0 - (Player[playerid][XP] / 40)),1);	// take death penalty xp
	}
	else
	{
		SetPlayerXP(playerid,0);
	}
}

public PlayerKill(killerid, victimid, reason) // earn xp, kills++
{
    // check gang kill
    if (PlayerGangid[killerid] != 0)
	{
	    if (GangKill(PlayerGangid[killerid],killerid,victimid,reason) == 1) return;
	}
	
	// check weapon
	if (IsWeapon(reason))
	{
		if (PlayerWeapons[killerid][reason] > 0)
		{
	    	if (!IsWeaponHandToHand(reason))
			{
			    new lostbullets;
			    lostbullets = Vary(2,1);
				PlayerWeapons[killerid][reason] = PlayerWeapons[killerid][reason] - lostbullets;
				if (PlayerWeapons[killerid][reason] < 0) PlayerWeapons[killerid][reason] = 0;
			 }
		}
		else if (reason != 0)// killer used weapon they should not have
		{
			if (!IsStoreWeapon(reason)) // check not store bought weapon
			{
			    new string[MAX_STRING];
			    format(string,sizeof(string),"Bad Weapon! (%d)",reason);
			    KickPlayer(killerid,string); //kick player, they used illegal weapon
			    return;
			}
		}
	}
	
	Player[killerid][Kills]++;
	PlayerCurrentKills[killerid]++;
	
	// earn xp
	new earnedXP;
	earnedXP = ((1+Player[victimid][Level]) * 50);
	if (earnedXP > (1+Player[killerid][Level]) * 100)
	{
	    earnedXP = ((1+Player[killerid][Level]) * 100);
	}
	if ((Player[killerid][XP] + earnedXP) <= MAX_XP)
	{
		GivePlayerXP(killerid, earnedXP,1);
	}
	else
	{
	    SetPlayerXP(killerid, MAX_XP);
	}
	
	// steal cash
	new stolencash;
	if (oGetPlayerMoney(victimid) > 1000)
	{
		stolencash = (oGetPlayerMoney(victimid) - (oGetPlayerMoney(victimid) / 10));
	}
	else
	{
		stolencash = oGetPlayerMoney(victimid);
	}
	oGivePlayerMoney(victimid,0-stolencash,1);
	oGivePlayerMoney(killerid,stolencash,1);
	
    return;
}

public RegisterQuest(name[MAX_NAME])
{
    if (QuestCount >= MAX_QUESTS) return 0;
	QuestCount++;
	new questid =QuestCount;
	set(Quests[questid][Quest_Name],name);
	return questid;
}

public ResetQuest(playerid)
{
		oDisablePlayerCheckpoint(playerid);
		PlayerQuest[playerid] = 0;
}

public oSetPlayerCheckpoint(playerid, Float:x, Float:y, Float:z, Float:size)
{
	DisablePlayerCheckpoint(playerid);
	PlayerCP[playerid][Coord_X] = x;
	PlayerCP[playerid][Coord_Y] = y;
	PlayerCP[playerid][Coord_Z] = z;
	PlayerCPActive[playerid] = true;
	SetPlayerCheckpoint(playerid, x, y, z, 6);// size); // TODO: size bugged
}

public oDisablePlayerCheckpoint(playerid)
{
    DisablePlayerCheckpoint(playerid);
    PlayerCPActive[playerid] = false;
 	PlayerCP[playerid][Coord_X] = 0;
	PlayerCP[playerid][Coord_Y] = 0;
	PlayerCP[playerid][Coord_Z] = 0;
}

public oIsPlayerInCheckpoint(playerid,Float:cpx,Float:cpy,Float:cpz,dist)
{
	if (!IsPlayerConnected(playerid)) {return 0;}
	if (!PlayerCPActive[playerid]) {return 0;}
	if (!loccmp(cpx,cpy,cpz,PlayerCP[playerid][Coord_X],PlayerCP[playerid][Coord_Y],PlayerCP[playerid][Coord_Z])) return 0;
	new Float:playerx,Float:playery,Float:playerz;
	GetPlayerPos(playerid,playerx,playery,playerz);

	if (GetDistanceXYZtoXYZ(playerx,playery,playerz,cpx,cpy,cpz) < dist)
	{
	    return IsPlayerInCheckpoint(playerid);
	}
	return 0;
}

public Float:GetMaxHealth(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0.0;}
	new Float:maxhealth=50.0;
	if (Player[playerid][Level] == 0) {return 50.0;}
	if (Player[playerid][Level] >= 10) return 100.0;
	maxhealth = (50.0 + (Player[playerid][Level] * 5.0));
	return maxhealth;
}

public GetXPToLevel(playerid,level)
{
	if (!IsPlayerConnected(playerid)) {return 0;}
	new xptolevel;
	xptolevel=0;
	if ((level <= MAX_LEVEL) && (level > Player[playerid][Level]))
	{
		xptolevel =LevelList[level] - Player[playerid][XP];
 	}
    else
    {
        xptolevel = 0;
	}
	return xptolevel;
}

public CalculatePlayerLevel(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0;}
	new level;
	level = 0;
	
	for (new i = 0; i <= MAX_LEVEL; i++)
	{
		if (GetPlayerXP(playerid) >=LevelList[i])
		{
	    	level = i;
		}
	}
 	return level;
 }

public GetPlayerLevel(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0;}
	return Player[playerid][Level];
}

public GetPlayerXP(playerid)
{
    if (!IsPlayerConnected(playerid)) {return 0;}
	return Player[playerid][XP];
}

public SetPlayerXP(playerid, xpamount)
{
    if (!IsPlayerConnected(playerid)) return;
	Player[playerid][XP] = xpamount;
}

public GivePlayerXP(playerid, xpamount,showtext) // showtext = do we display "You gain %d XP"  to client
{
    if (!IsPlayerConnected(playerid)) return;
    if (xpamount == 0) return;
    
    if (PlayerGangid[playerid] != 0)
    { // in a gang
        if (xpamount > 100)
        {
            new gangxp = xpamount / 4;
    		new string[MAX_STRING];
			format(string, sizeof(string), "Your recieve %d gang xp.", gangxp);

			SendGangMessage(PlayerGangid[playerid],string,COLOR_XP_GOOD);
			GangGiveXP(PlayerGangid[playerid],gangxp,playerid);

		}
    }
    
    new texttime;
	if (xpamount <= 50)
	{
		texttime = 500;
	}
	else if (xpamount < 200)
	{
	    texttime = 1000;
	}
	else if (xpamount < 500)
	{
	    texttime = 1500;
	}
	else if (xpamount < 1000)
	{
	    texttime = 2000;
	}
	else if (xpamount < 2000)
	{
	    texttime = 4000;
	}
	else
	{
		texttime = 5000;
	}
    
	new string[256];
	if ((GetPlayerXP(playerid) + xpamount) < 0) // if after add xp, playerxp < 0
	{
		SetPlayerXP(playerid, 0);
		if (showtext == 1)
		{
			format(string, sizeof(string), "You loose %d XP.", xpamount);
			SendClientMessage(playerid, COLOR_XP_BAD, string);
		}
		return;
	}
	
	if ((GetPlayerXP(playerid) + xpamount) > MAX_XP) // if after add, playerxp > MAX
	{
		if (showtext == 1)
		{
			format(string, sizeof(string), "You gain %d XP.", MAX_XP - GetPlayerXP(playerid));
			SendClientMessage(playerid, COLOR_XP_GOOD, string);
			SendClientMessage(playerid, COLOR_RED, "You can gain no more XP!");
		}
		SetPlayerXP(playerid, MAX_XP);
		return;
	}
	
	SetPlayerXP(playerid, (GetPlayerXP(playerid) + xpamount));
	
	if (showtext==1)
	{
		if (xpamount >= 0)
		{
			format(string, sizeof(string), "You gain %d XP.", xpamount);
			SendClientMessage(playerid, COLOR_XP_GOOD, string);
		}
		else
		{
			format(string, sizeof(string), "You loose %d XP.", xpamount);
			SendClientMessage(playerid, COLOR_XP_BAD, string);
		}
	}
	
	if (xpamount >= 0)
	{
		format(string, sizeof(string), "+%d XP", xpamount);
		GameTextForPlayer(playerid,string,texttime,3);
	}
	else
	{
		format(string, sizeof(string), "-%d XP", xpamount);
		GameTextForPlayer(playerid,string,texttime,3);
	}
	CheckPlayerLevel(playerid);
}

public CheckPlayerLevel(playerid)
{
    if (!IsPlayerConnected(playerid)) {return;}
	new level;
	level = CalculatePlayerLevel(playerid);
	if (Player[playerid][Level] < level)
	{
	    PlayerLevelUp(playerid,level);
	}
	else if (Player[playerid][Level] > level)
	{
	    PlayerLevelDown(playerid,level);
	}
}

public PlayerLevelDown(playerid,level)
{
	if (!IsPlayerConnected(playerid)) {return;}
	new string[256];
    Player[playerid][Level] = level;
	format(string, sizeof(string), "You are back to level %d", Player[playerid][Level]);
	SendClientMessage(playerid, COLOR_XP_BAD, string);
	new Float:playerx,Float:playery,Float:playerz;
	GetPlayerPos(playerid,playerx,playery,playerz);
	PlayerPlaySound(playerid,1057,playerx,playery,playerz);
	UpdatePlayerScore(playerid);
}

public PlayerLevelUp(playerid,level)
{
    if (!IsPlayerConnected(playerid)) {return;}
	new string[256];
    Player[playerid][Level] = level;
	GivePlayerOwnedWeapons(playerid);
	oSetPlayerHealth(playerid,GetMaxHealth(playerid));
	format(string, sizeof(string), "You are now level %d", Player[playerid][Level]);
	SendClientMessage(playerid, COLOR_XP_GOOD, string);
	new Float:playerx,Float:playery,Float:playerz;
	GetPlayerPos(playerid,playerx,playery,playerz);
	PlayerPlaySound(playerid,1057,playerx,playery,playerz);
	UpdatePlayerScore(playerid);
	
	format(string, sizeof(string), "New weapons available:");
	new wepfound;
	for (new weaponid=1;weaponid<MAX_WEAPONS;weaponid++)
	{
		new lookupid=GetWeaponLookupID(weaponid);
		if (lookupid == -1) continue;
		if (Weapons[lookupid][Weapon_Allowed] == 0) continue;
		if (Weapons[lookupid][Weapon_Level] == GetPlayerLevel(playerid))
		{
		    if (wepfound == 0)
		    {
				SendClientMessage(playerid, COLOR_GREEN, "New weapons available:");
				wepfound=1;
			}
			format(string, sizeof(string), "Weapon: '%s'. Price: %d.",oGetWeaponName(weaponid),GetWeaponCost(weaponid));
            SendClientMessage(playerid, COLOR_MISC, string);
		}
	}
	
}

public oSetPlayerMoney(playerid,money)
{
	if (!IsPlayerConnected(playerid)) return;
	SetPlayerMoney(playerid,money);
 	Player[playerid][Money] = money;
	MoneyUpdateDelay[playerid] = 1;
	return;
}

public oGivePlayerMoney(playerid,money,showtext)
{
	if (!IsPlayerConnected(playerid))	return;
	if (money == 0) return;
	new string[MAX_STRING];
	
	if (showtext == 1)
	{
		if (money >= 0)
		{
			format(string, sizeof(string), "You recieve $%d.", money);
			SendClientMessage(playerid, COLOR_MONEY_GOOD, string);
		}
		else
		{
			format(string, sizeof(string), "You loose $%d.", money);
			SendClientMessage(playerid, COLOR_MONEY_BAD, string);
		}
	}
	
	oSetPlayerMoney(playerid,Player[playerid][Money] + money);
}

public GetPlayerTotalMoney(playerid)
{
	new money=0;
	money = money + Player[playerid][Money];
	money = money + Player[playerid][Bank];
	return money;
}

public oGetPlayerMoney(playerid)
{
	return Player[playerid][Money];
}

public UpdatePlayerScore(playerid)
{
	SetPlayerScore(playerid,Player[playerid][Level]);
}
		
public oGetPlayerName(playerid)
{
	new name[MAX_PLAYER_NAME];
	GetPlayerName(playerid, name, sizeof (name));
	return name;
}

public Float:oGetPlayerHealth(playerid)
{
	new Float:health;
	GetPlayerHealth(playerid, health);
	return health;
}

public oSetPlayerHealth(playerid,Float:health)
{
	Player[playerid][Health] = health;
	SetPlayerHealth(playerid, health);
	HealthUpdateDelay[playerid] = 1;
}

public oGivePlayerWeapon(playerid,weaponid,ammo)
{
	if (ammo > 0)
	{
		if (!IsWeaponHandToHand(weaponid))
		{
	    	PlayerWeapons[playerid][weaponid] = PlayerWeapons[playerid][weaponid] + ammo;
		}
		else
		{
			PlayerWeapons[playerid][weaponid] = 1;
		}
		GivePlayerWeapon(playerid,weaponid,ammo);
	}
}

public PlayerSave(playerid)
{
	if (!IsPlayerRegistered(playerid))
	{
		#if DEBUGLEVEL > 1
			printf("player_save: FAILED: player not registered%d  %s",playerid,oGetPlayerName(playerid));
		#endif
		return 0;
	}
	
	#if DEBUGLEVEL > 0
		printf("player_save: %s",oGetPlayerName(playerid));
	#endif
	
	new filename[MAX_STRING];
	new dbstring[MAX_DBSTRING];
	filename = oGetPlayerName(playerid);
  	strcat(filename,".Status",sizeof(filename));
  	if (!udb_Exists(filename))
	{
		#if DEBUGLEVEL > 1
			printf("player_stats_save: fail: stats doesnt exists: %s",oGetPlayerName(playerid));
		#endif
		SendClientMessage(playerid,COLOR_RED, "ERROR: Player status doesnt exists.");
		return 0;
	}
	
	dbstring = CreateDBStatsString(playerid);
	udb_Savefile(filename,dbstring);
	SendClientMessage(playerid,COLOR_GREEN, "Player saved.");
	#if DEBUGLEVEL > 0
		printf("player_save: Success%s",oGetPlayerName(playerid));
	#endif
	#if OUTPUTLEVEL > 0
		printf("player_save: success %d  %s",playerid,oGetPlayerName(playerid));
	#endif

	return 1;
}

public CreatePlayer(playerid)
{

	oSetPlayerMoney(playerid,300);
	SetPlayerXP(playerid,0);
	ResetPlayerWeapons(playerid);
	oGivePlayerWeapon(playerid,WEAPON_COLT45,100);

	new filename[MAX_STRING];
	new dbstring[MAX_DBSTRING];
	filename = oGetPlayerName(playerid);
 	strcat(filename,".Status",sizeof(filename));
  	if (udb_Exists(filename))
	{
		SendClientMessage(playerid,COLOR_RED, "ERROR: Player status already exists.");
		return;
	}
	else
	{
		dbstring = CreateDBStatsString(playerid);
		udb_Create(filename,dbstring);
		#if DEBUGLEVEL > 0
			printf("create_player: success %s",filename);
		#endif
		#if OUTPUTLEVEL > 0
			printf("create_player: success %d  %s",playerid,oGetPlayerName(playerid));
		#endif
	}
	return;
}

public PlayerLoadStats(playerid)
{
	if (!IsPlayerRegistered(playerid)) return 0; // login to acct first
	new filename[MAX_STRING];
	new statsdbstring[MAX_DBSTRING];
	filename = oGetPlayerName(playerid);
  	strcat(filename,".Status",sizeof(filename));

 	if (!udb_Exists(filename))
	{
		#if DEBUGLEVEL > 0
			printf("load stats : fail: %s",filename);
		#endif
		return 0;
	}
	else
	{
		statsdbstring = udb_Loadfile(filename);
	}
 	new idx;
	strcharsplit(statsdbstring,idx,DBSeperator); // playername
	// set stats
	Player[playerid][Level] = strval(strcharsplit(statsdbstring,idx,DBSeperator));
	Player[playerid][XP] = strval(strcharsplit(statsdbstring,idx,DBSeperator));
	oSetPlayerMoney(playerid,strval(strcharsplit(statsdbstring,idx,DBSeperator)));
	Player[playerid][Deaths] = strval(strcharsplit(statsdbstring,idx,DBSeperator));
 	Player[playerid][Kills] = strval(strcharsplit(statsdbstring,idx,DBSeperator));
   	Player[playerid][CarKills] = strval(strcharsplit(statsdbstring,idx,DBSeperator));
	Player[playerid][Bank] = strval(strcharsplit(statsdbstring,idx,DBSeperator));
    PlayerSpawn[playerid][Coord_X] = floatstr(strcharsplit(statsdbstring,idx,DBSeperator));
    PlayerSpawn[playerid][Coord_Y] = floatstr(strcharsplit(statsdbstring,idx,DBSeperator));
    PlayerSpawn[playerid][Coord_Z] = floatstr(strcharsplit(statsdbstring,idx,DBSeperator));
   	new gangname[MAX_NAME];
	set(gangname,strcharsplit(statsdbstring,idx,DBSeperator));
   	if (gangname[0] != 0)
   	{
   		set(PlayerGangName[playerid],gangname);
   		PlayerGangid[playerid] = GangLoad(gangname);
   		GangMemberLogin(playerid,PlayerGangid[playerid]);
   		if (PlayerGangid[playerid] == 0)
   		{
   			printf("player_gang: not found: %s",gangname);
   			new tmpname[MAX_NAME];
   			set(PlayerGangName[playerid],tmpname);
   			PlayerGangName[playerid][0] = 0;
   			PlayerGangid[playerid] = 0;
   		}
   		// TODO:
	}
	else
	{
		printf("no gang");
		PlayerGangid[playerid] = 0; // no gang
	}
	new wepstr[MAX_STRING];
	set(wepstr,strcharsplit(statsdbstring,idx,DBSeperator));
	SetWeaponsFromDBString(playerid,wepstr);
	UpdatePlayerScore(playerid);
	return 1;
}

SetWeaponsFromDBString(playerid,dbstring[])
{
	new idx;
	for (new i=0;i<MAX_WEAPONS;i++)
	{
	    new bullets;
		bullets = strval(strcharsplit(dbstring,idx,strchar("/")));
		PlayerWeapons[playerid][i] = bullets;
	}
}

CreateWeaponDBString(playerid)
{
	new wepstr[MAX_STRING];
	for (new i=0;i<MAX_WEAPONS;i++)
	{
	    new temp[MAX_STRING];
	    valstr(temp,PlayerWeapons[playerid][i]); // level
		strins(wepstr, temp, strlen(wepstr));
		wepstr[strlen(wepstr)] =strchar("/");
	}
	return wepstr;
}

CreateDBStatsString(playerid)
{
   	new dbstring[MAX_DBSTRING];
   	new temp[MAX_STRING];

	strins(dbstring, oGetPlayerName(playerid), strlen(dbstring)); // name
	dbstring[strlen(dbstring)] =DBSeperator;

	valstr(temp,Player[playerid][Level]); // level
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;

	valstr(temp,Player[playerid][XP]); // xp
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;

 	valstr(temp,Player[playerid][Money]); // money
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;

	valstr(temp,Player[playerid][Deaths]); // deaths
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;

	valstr(temp,Player[playerid][Kills]); // kills
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;

	valstr(temp,Player[playerid][CarKills]); // carkills
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;

	valstr(temp,Player[playerid][Bank]); // bankmoney
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;
	
	new Float:playerx, Float:playery, Float:playerz;
 	GetPlayerPos(playerid,playerx,playery,playerz);
    if (playerz > 900)
    { // we must be indoors
        playerx=0;
        playery=0;
        playerz=0;
	}
 	format(temp,sizeof(temp),"%f",playerx);
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;
	
	format(temp,sizeof(temp),"%f",playery);
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;
	
	format(temp,sizeof(temp),"%f",playerz);
	strins(dbstring, temp, strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;
	
	strins(dbstring, PlayerGangName[playerid], strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;
	
	strins(dbstring, CreateWeaponDBString(playerid), strlen(dbstring));
	dbstring[strlen(dbstring)] =DBSeperator;
	
	return dbstring;
	
}

